#include "file_handling.h"

extern PREFS Prefs;

// handle a given file //
void handle_file(char *Path, char *Name, int Id)
{
    // vars //
    char buffer[108],buffer2[216];
    int type=0;

    // functions //
    BOOL IsExe(char *FileName);
    BOOL IsText(char *FileName);
    BOOL HasInfo(char *FileName);
    BOOL IsDatatype(char *FileName);

    if(Path[strlen(Path)-1] == ':') sprintf(buffer,"%s%s",Path,Name);
    else sprintf(buffer,"%s/%s",Path,Name);

    printf("[HANDLE FILE] Using file \"%s\"\n",buffer);

    // here begin tests for types //
    if((type=FindType(Name))!=-1)
    {   if(ft[type].ExeType == INTERNAL)
        {   Exec_Internal(Path,Name,ft[type].internal);
            printf("[HANDLE FILE] File type is handled internaly...\n");
        }
    }
    else
    {   if(IsExe(buffer))
        {   printf("[HANDLE FILE] File is executable\n");
            if(HasInfo(buffer)==TRUE)
            {   printf("[HANDLE FILE] File has an icon, launch it via Workbench.library\n");
                if((OpenWorkbenchObjectA(buffer,TAG_DONE))==FALSE)
                {   Fault(IoErr(),NULL,buffer,108);
                    printf("\nError: %s\n",buffer);
                }
            }
        }
        else
        {   if(IsText(buffer))
            {   printf("[HANDLE FILE] File type is text\n");
                sprintf(buffer2,"run <>NIL: %s %s >NIL:",Prefs.DefaultText,buffer);
                SystemTags(buffer2,NP_CloseOutput,FALSE,NP_CloseInput,FALSE,NP_StackSize,Prefs.DefaultStack,TAG_DONE);
            }
            else
            {   if(IsDatatype(buffer))
                {   printf("[HANDLE FILE] File type is datatype\n");
                    sprintf(buffer2,"run <>NIL: %s %s >NIL:",Prefs.DefaultDT,buffer);
                    //kprintf("%s\n",buffer2);
                    printf("[HANDLE FILE] Launching \"%s\"\n",buffer2);
                    SystemTags(buffer2,NP_CloseOutput,FALSE,NP_CloseInput,FALSE,NP_StackSize,Prefs.DefaultStack,TAG_DONE);
                }
                else printf("\nUnknown file type !\n");
            }
        }
    }
}

// tell if file is an executable //
BOOL IsExe(char *FileName)
{   FILE *file;
    ULONG buffer;

    if(file=fopen(FileName,"r"))
    {   fread(&buffer,sizeof(ULONG),1,file);
        fclose(file);
        if(buffer==AMIGAOS_EXE || buffer==MORPHOS_EXE ) return TRUE;
    }

    return FALSE;
}

// tell if file has an icon //
BOOL HasInfo(char *FileName)
{   char *comp;
    FILE *file;
    BOOL retval=FALSE;

    if((comp = malloc(strlen(FileName)+5)))
    {   strcpy(comp,FileName);
        strcat(comp,".info");

        if((file=fopen(comp,"r")))
        {   retval = TRUE;
            fclose(file);
        }

        free(comp);
    }

    return retval;
}

// tell if file is a text one //
BOOL IsText(char *FileName)
{   struct DataType *DT;
    BPTR lock;
    BOOL retval=FALSE;

    if((lock=Lock(FileName,ACCESS_READ))!=0)
    {   if((DT = ObtainDataType(DTST_FILE,(APTR)lock,TAG_DONE)))
        {   if(DT->dtn_Header->dth_GroupID == GID_TEXT)
                retval=TRUE;
            //FreeDataType(DT);
        }
        UnLock(lock);
    }

    return retval;
}

// test if the type of file is a known datatype //
BOOL IsDatatype(char *FileName)
{   struct DataType *DT;
    BPTR lock;
    BOOL retval=FALSE;

    if((lock=Lock(FileName,ACCESS_READ))!=0)
    {   if((DT = ObtainDataType(DTST_FILE,(APTR)lock,TAG_DONE)))
            retval=TRUE;
            //FreeDataType(DT);
        UnLock(lock);
    }

    return retval;
}
