#ifdef __MORPHOS__
#include <ppcinline/macros.h>
#endif

#include <clib/debug_protos.h> //SS-TBD to be removed


#include "Listers_cat.h"
#include "Types.h"
#include "Prefs.h"
#include "ListersGUI.h"
#include "Main.h"

/* needed libraries */
struct Library * IntuitionBase  = NULL;
struct Library * LayersBase     = NULL;
struct Library * CxBase         = NULL;
struct Library * MUIMasterBase  = NULL;
struct Library * LocaleBase     = NULL;
struct Library * NListBase      = NULL;
struct Library * NListViewBase  = NULL;
struct Library * IconBase       = NULL;
struct Library * WorkbenchBase  = NULL;
struct Library * DataTypesBase  = NULL;
struct Library * UtilityBase    = NULL;


/* this is the commodity structure */
struct NewBroker newbroker =
{   NB_VERSION,
    COMMODITY_NAME,
    COMMODITY_TITLE,
    COMMODITY_DESC,
    NBU_UNIQUE,
    0,
    0,
    0,
    0
};


/* globals vars */
CxObj *broker=NULL,*custom=NULL;
struct Screen *WBScreen = NULL;
struct Window *WBWindow = NULL;

struct Mymsg *MyMsg=NULL;



extern LONG MainLister(void);

static void MsgTesterPPC(void);
struct EmulLibEntry CxFunction_GATE = { TRAP_LIB, 0, MsgTesterPPC };

static LONG OpenLibs( void );
static void CloseLibs( void );
static void ProcessMsg(struct MsgPort *pm_broker, struct MsgPort *pm_custom);

static void DestroyListerProcess(void);
struct EmulLibEntry ExitCode_GATE = { TRAP_LIB, 0, (void (*)(void)) DestroyListerProcess};



/* AddListerProcess() function: add a lister process to chained list */
BOOL AddListerProcess(struct Process *proc)
{   struct MyList *newlister;

	if((newlister = malloc(sizeof(struct MyList))) != NULL);
    {   newlister->Lister_process = proc;
        newlister->Unique_ID = proc->pr_ExitData;
        newlister->Head = Env.Last_lister;
        newlister->Tail = NULL;
        if(Env.Last_lister==NULL) Env.Lister_list = newlister;
        else Env.Last_lister->Tail = newlister;
        Env.Last_lister = newlister;
        Env.Nb_Opened_Listers++;
        return TRUE;
    }

    return FALSE;
}

/* GetNodeByProcess() function: return the pointer to the entry */
/* of Env.Lister_list that contain the given process pointer    */
struct MyList * GetNodeByID(ULONG ID, struct MyList *node)
{       
    if(node==NULL) return NULL;
    if(node->Unique_ID == ID) return node;
	else return GetNodeByID(ID,node->Tail);

}

/* DestroyListerProcess() function: remove a given lister from chained list     */
/* !! WARNING !! it is impossible to know if deletion was succesfull: it should */
/* only be called automatically by AmigaDOS when process is ending              */
static void DestroyListerProcess(void) //SS-TBD : handle for amigaos
{
    ULONG ID = (ULONG) REG_D1;
    
    struct MyList *node = NULL;
	if((node = GetNodeByID(ID,Env.Lister_list)) != NULL)
    {
        /* case node is the only one in the list */
        if(node->Head == NULL && node->Tail == NULL)
        {   Env.Last_lister = NULL;
            Env.Lister_list = NULL;
        }
        /* case node is the last node of the list */
        else if(node == Env.Last_lister)
        {   node->Head->Tail = NULL;
            Env.Last_lister = node->Head;
        }
        /* case it's the first node of the list */
        else if(node->Head==NULL)
        {   node->Tail->Head = NULL;
            Env.Lister_list  = node->Tail;
        }
        /* case node is anywhere else */
        else
        {   node->Head->Tail = node->Tail;
            node->Tail->Head = node->Head;
        }

        free(node->Lister_process->pr_Task.tc_UserData);
        free(node);

        Env.Nb_Opened_Listers--;
    }
}



/* IsWBIconsSelected(): return TRUE if there's at least one selected icon on WB */
BOOL IsWBIconsSelected()
{//   struct List *SelectedIcons = NULL;
    /*BOOL RetVal = FALSE;*/

/*    if(WorkbenchControl(NULL,WBCTRLA_GetSelectedIconList,&SelectedIcons,TAG_DONE))
    {   RetVal = IsListEmpty(SelectedIcons) ? FALSE:TRUE;
        WorkbenchControl(NULL,WBCTRLA_FreeSelectedIconList,SelectedIcons,TAG_DONE);
    }
*/
    return FALSE;/*RetVal;*/
}

/* this function check if last MouseUP was a DragDrop for a lister */
void CheckDrop()
{   if(Env.Dragged_ID)
    {   struct Layer  *ClickedLayer  = NULL;
        struct Window *ClickedWindow = NULL;
        struct Task   *task          = NULL;

        if((ClickedLayer = (struct Layer *)WhichLayer(&WBScreen->LayerInfo,WBScreen->MouseX,WBScreen->MouseY)));
        {   if((ClickedWindow = (struct Window *)ClickedLayer->Window))
            {   if((ClickedWindow->UserPort->mp_Flags&PF_ACTION)==PA_SIGNAL)
                {   task = ClickedWindow->UserPort->mp_SigTask;
                    if(((struct TaskData *) (task->tc_UserData))->Unique_ID != Env.Dragged_ID )
                    {   struct MyList *node,*node2;
                        node  = GetNodeByID(((struct TaskData *) (task->tc_UserData))->Unique_ID,Env.Lister_list);
                        node2 = GetNodeByID(Env.Dragged_ID, Env.Lister_list);
                        DoMethod(((struct ObjApp *) (node->Lister_App))->LV_lister,MUIM_ExternDrop,node2->Lister_App);
                    }
                }
            }
        }
        
        Env.Dragged_ID = 0; /* NULL */
    }
}



/* convert a string "LMB", "RMB", MMB" into Input event code */
UWORD BtStr2IECode(STRPTR button)
{   if(!(stricmp(button,"LMB"))) return IECODE_LBUTTON;
    if(!(stricmp(button,"MMB"))) return IECODE_MBUTTON;
    if(!(stricmp(button,"RMB"))) return IECODE_RBUTTON;
}


/* Find wb main window through WBScreen linked windows list */
struct Window * GetWBWindow(struct Window *win)     //SS-TBD : temporary
{
	if(win==NULL) return NULL;

	if(win->Flags & WFLG_BACKDROP)
	{
		return win;
	}

	else return GetWBWindow(win->NextWindow);
}
struct Window * GetWBWindowOLD(struct Window *win)
{
	printf("dans fonction : win ptr = %ld",(long)win);
    if(win==NULL) { printf("Niark !\n\n");return NULL; }
    else
    {   struct Task *task=NULL;
        printf("Searching...\n\n");
        if(win->IDCMPFlags & IDCMP_DISKINSERTED)                        /* Only OS window (and requesters) can have this flag   */
        {   printf("OS Window test...\n\n");
            if((win->UserPort->mp_Flags&PF_ACTION)==PA_SIGNAL)          /* is a task assigned to this window ?                  */
            {   printf("Task search...\n\n");
                task = win->UserPort->mp_SigTask;                       /* get task                                             */
                printf("MagicTask = %s",(task->tc_Node.ln_Name));
                if(!strcmp((task->tc_Node.ln_Name),CXPrefs.MagicTask))  /* is Task name is the MAGICTASK ?                      */
                    return win;                                         /* now we are sure it's the WB window !                 */
            }
        }

        GetWBWindow(win->NextWindow);
    }
}


/* here is the begining ! */
int main(int argc, char **argv)
{
	struct MsgPort *broker_mp=NULL,*custom_mp=NULL;
	ULONG cxsigflag = 0;
	ULONG customsigflag = 0;
	CxMsg *msg;

	if(OpenLibs() != 0)
	{
		printf("Cannot open all libs, exiting\n");
		exit(EXIT_FAILURE);
	}
	WBScreen = LockPubScreen("Workbench");
	if(WBScreen == NULL)
	{
		printf("Fatal error: could not Get WB Screen !!!");
		CloseLibs();
        exit(EXIT_FAILURE);
	}
    OpenAppCatalog(NULL,NULL);
    LoadPrefs();
    LoadTypes();

    if(!InitClasses())
	{
		printf("Custom class creation failed !");
		ExitClasses();
		FreeTypes();
		CloseAppCatalog();
		CloseLibs();
		exit(EXIT_FAILURE);
    }

    printf("[MAIN] Start Main_Lister\n");
//	  MainLister();
    printf("[MAIN] Main_Lister finished...\n");


   /* program start is here ! */
   if (((broker_mp = CreateMsgPort()) != NULL) && ((custom_mp = CreateMsgPort()) != NULL))
   {
        /* init commodity */
        newbroker.nb_Port = broker_mp;
		newbroker.nb_Pri = 0;//SS-TBD (BYTE)ArgInt(Args, "CX_PRIORITY", 0);

		if ((broker = CxBroker(&newbroker, NULL)) != NULL)
        {

            /* get ToolType prefs */
			CXPrefs.MagicTask       = MAGICTASK_DEFAULT_NAME;//SS-TBD ArgString(Args, "MAGICTASK", MAGICTASK_DEFAULT_NAME);
			CXPrefs.MouseButton     = BtStr2IECode(DEFAULT_MOUSE_BUTTON);//SS-TBD BtStr2IECode(ArgString(Args, "BUTTON", DEFAULT_MOUSE_BUTTON));
			CXPrefs.Lister_Stack    = DEFAULT_LISTER_STACK;//SS-TBD ArgInt(Args,"STACK",DEFAULT_LISTER_STACK);
			CXPrefs.Lister_TaskName = DEFAULT_LISTER_TASKNAME;//SS-TBD ArgString(Args,"TASKNAME",DEFAULT_LISTER_TASKNAME);

			printf("WBScreen adresse = 0x%lx\nFirst Win adr = 0x%lx\n", (long)WBScreen, (long)(WBScreen->FirstWindow));

			WBWindow = GetWBWindow(WBScreen->FirstWindow);
			if(WBWindow != NULL)
			{
				ActivateCxObj(broker, 1L);                /* activate commodity                                     */
				custom = CxCustom(&CxFunction_GATE, (LONG)custom_mp);    /* declare Event tester                                   */
				AttachCxObj(broker, custom);              /* Tell Commodity to call Our msg tester when msg arrive  */
				ProcessMsg(broker_mp, custom_mp);         /* notifycation handling                                  */
			}
			DeleteCxObjAll(broker);                       /* destroy commodity                                      */
            if(MyMsg) FreeVec(MyMsg);

            //if some msg are still in stack, reply to free them
		   while((msg = (CxMsg *)GetMsg(broker_mp)) != NULL)
                ReplyMsg((struct Message *)msg);

		} //if (broker = CxBroker(&newb...

        /* free commodity's Msg port */
        DeletePort(broker_mp);
        DeletePort(custom_mp);
	} //if ((broker_mp = CreateMsgPort...

    /* free ressources and close libraries */
	printf("[MAIN] Exit Classes\n");
    ExitClasses();

    printf("[MAIN] Free types\n");
    FreeTypes();

	printf("[MAIN] Close AppCatalog\n");
    CloseAppCatalog();

	UnlockPubScreen(NULL, WBScreen);

    printf("[MAIN] Close Libraries\n");
	CloseLibs();

    printf("[MAIN] Finished, going to return 0...\n");
    return 0;
}

int mainOLD(int argc, char **argv)
{
    /* vars */
    //CxMsg *msg;
    //UBYTE **Args=NULL;
    //void __saveds MsgTester(CxMsg *msg, CxObj *obj);
    //void ProcessMsg(void);

    /* initialisation */
    //Args = ArgArrayInit(argc,(UBYTE **)argv);
    //Env.Dragged_ID = 0; /* NULL */
	if(OpenLibs() != 0)
	{
		printf("Cannot open all libs, exiting\n");
		exit(EXIT_FAILURE);
	}
    OpenAppCatalog(NULL,NULL);
    LoadPrefs();
    LoadTypes();
    /*if(!(WBScreen = (struct Screen *)OpenWorkBench()))
    {   Fail("Fatal error: could not Get WB Screen !!!");
        return 20;
    } */

    if(!InitClasses())
	{
		printf("Custom class creation failed !");
		ExitClasses();
		FreeTypes();
		CloseAppCatalog();
		CloseLibs();
		exit(EXIT_FAILURE);
    }

    printf("[MAIN] Start Main_Lister\n");
//SS-TBD	MainLister();
    printf("[MAIN] Main_Lister finished...\n");
   /* program start is here ! */
//   if ((broker_mp = CreateMsgPort()) && (custom_mp = CreateMsgPort()))
//   {
        /* init commodity */
/*        newbroker.nb_Port = broker_mp;
        newbroker.nb_Pri = (BYTE)ArgInt(Args, "CX_PRIORITY", 0);

        if (broker = CxBroker(&newbroker, NULL))
        {
*/
            /* get ToolType prefs */
/*            CXPrefs.MagicTask       = ArgString(Args, "MAGICTASK", MAGICTASK_DEFAULT_NAME);
            CXPrefs.MouseButton     = BtStr2IECode(ArgString(Args, "BUTTON", DEFAULT_MOUSE_BUTTON));
            CXPrefs.Lister_Stack    = ArgInt(Args,"STACK",DEFAULT_LISTER_STACK);
            CXPrefs.Lister_TaskName = ArgString(Args,"TASKNAME",DEFAULT_LISTER_TASKNAME);

            printf("WBScreen adresse = %0x\nFirst Win adr = %0x\n",WBScreen,WBScreen->FirstWindow);


            if(!(WBWindow = GetWBWindow(WBScreen->FirstWindow)))
            {   Fail("Fatal error: could not find Main OS Window (WB Main window) !\n Make sure MagicTask is well named...\n");
                DeletePort(broker_mp);
                return 20;
            }

            cxsigflag = 1L << broker_mp->mp_SigBit;
            customflag = 1L << custom_mp->mp_SigBit;
*/
//            ActivateCxObj(broker, 1L);                /* activate commodity                                     */
//            custom = CxCustom(MsgTester,0);           /* declare Event tester                                   */
//            AttachCxObj(broker, custom);              /* Tell Commodity to call Our msg tester when msg arrive  */
//            ProcessMsg();                             /* notifycation handling                                  */
//            DeleteCxObjAll(broker);                   /* destroy commodity                                      */
//            if(MyMsg) FreeVec(MyMsg);

            //if some msg are still in stack, reply to free them
//            while(msg = (CxMsg *)GetMsg(broker_mp))
//                ReplyMsg((struct Message *)msg);

//        }

        /* free commodity's Msg port */
//        DeletePort(broker_mp);
//        DeletePort(custom_mp);
//    }
    /* free ressources and close libraries */

	printf("[MAIN] Exit Classes\n");
    ExitClasses();

    printf("[MAIN] Free types\n");
    FreeTypes();
	printf("[MAIN] Close AppCatalog\n");
    CloseAppCatalog();
    printf("[MAIN] Close Libraries\n");
	CloseLibs();

    /* free memory allocated for Tooltype */
    printf("[MAIN] ArgArrayDone\n");
    //ArgArrayDone();
    printf("[MAIN] Finished, going to return 0...\n");
    return 0;
}


/************************************************************************/
/* IsMouseOverWB: tell weither mouse is over "MagicTask" windows or not */
/* !! WARNING !! function name is not always self explaining depending  */
/* on "MagicTask" name ("Workbench" most of the time)                   */
/************************************************************************/
BOOL IsMouseOverWB()
{
    struct Layer  *ClickedLayer  = NULL;
    struct Window *ClickedWindow = NULL;
//	  struct Task   *task          = NULL;

    /*if(!IsWBIconsSelected())*/                                                    /* first: trap all clicks done on icons                             */
       if((ClickedLayer = (struct Layer *)WhichLayer(&WBScreen->LayerInfo,WBScreen->MouseX,WBScreen->MouseY))); /* Get Layer on wicth user clicked...   */
		{
            if((ClickedWindow = (struct Window *)ClickedLayer->Window))             /* ...and then windows assigned to it                               */
			{
                if(ClickedWindow == WBWindow) return TRUE;
                /*if(ClickedWindow->IDCMPFlags & IDCMP_DISKINSERTED)*/                /* Only OS window can have this flag                                */
                /*{   if((ClickedWindow->UserPort->mp_Flags&PF_ACTION)==PA_SIGNAL)*/    /* is a task assigned to this window ?                              */
                    /*{   task = ClickedWindow->UserPort->mp_SigTask;             */    /* get task                                                         */
                    /*    if(!strcmp((task->tc_Node.ln_Name),CXPrefs.MagicTask))  */    /* is Task name is the MAGICTASK ?                                  */
                    /*       return TRUE;                                         */    /* now we are sure it's the OS background !                         */
                    /*}
                }*/
            }
        }


    return FALSE; /* At least one condition was not satisfied */
}


/* OpenLibs() function: open needed libraries */
static LONG OpenLibs( void )
{
    if (!(IntuitionBase = OpenLibrary("intuition.library", 37L)))
	{
        printf("Can't Open intuition Library\n");
		return -1;
    }

    if (!(UtilityBase = OpenLibrary("utility.library", 37L)))
	{
		printf("Can't Open utility Library\n");
		return -2;
    }

    if (!(LayersBase = OpenLibrary("layers.library", 37L)))
	{
		printf("Can't Open layers Library\n");
		return -3;
    }

    if (!(CxBase = OpenLibrary("commodities.library", 37L)))
	{
		printf("Can't Open commodities Library\n");
		return -4;
    }

    if (!(IconBase = OpenLibrary("icon.library", 37L)))
	{
        printf("Can't Open icon Library\n");
		return -5;
    }

    if (!(WorkbenchBase = OpenLibrary("workbench.library", 37L)))
	{
        printf("Can't Open workbench Library\n");
		return -6;
    }

    if (!(DataTypesBase = OpenLibrary("datatypes.library", 37L)))
	{
        printf("Can't Open datatypes Library\n");
		return -7;
    }

    if (!(MUIMasterBase = OpenLibrary(MUIMASTER_NAME,MUIMASTER_VMIN)))
	{
        printf("Can't Open MUIMaster Library\n");
		return -8;
    }

    if(!(NListBase=OpenLibrary("LIBS:mui/NList.mcc",19)))
	{
        printf("Can't Open NList.mcc\n");
		return -9;
    }

    if(!(NListViewBase=OpenLibrary("LIBS:mui/NListview.mcc",19)))
	{
        printf("Can't Open NListView.mcc\n");
		return -10;
    }

    if (!(LocaleBase = OpenLibrary("locale.library",38)))
	{
        printf("Can't Open Locale Library\n");
        printf("Built-in Language will be used !!!\n");
		return -11;
    }
    
	return 0;
}

/* CloseLibs() function: close libraries */
static void CloseLibs( void )
{
	if (LocaleBase)		CloseLibrary(LocaleBase);
	if (NListViewBase)	CloseLibrary(NListViewBase);
	if (NListBase)		CloseLibrary(NListBase);
	if (MUIMasterBase)	CloseLibrary(MUIMasterBase);
	if (DataTypesBase)	CloseLibrary(DataTypesBase);
	if (WorkbenchBase)	CloseLibrary(WorkbenchBase);
	if (IconBase)		CloseLibrary(IconBase);
	if (CxBase)			CloseLibrary(CxBase);
    if (LayersBase)		CloseLibrary(LayersBase);
	if (UtilityBase)	CloseLibrary(UtilityBase);
	if (IntuitionBase)	CloseLibrary(IntuitionBase);
}

/* Notification handler function */
static void ProcessMsg(struct MsgPort *pm_broker, struct MsgPort *pm_custom)
{
    /* vars */
    CxMsg *msg;
    /*struct Mymsg *msg2;*/
    ULONG sigrcvd, msgid, msgtype;
    struct Mymsg *msg2;
    LONG returnvalue = TRUE;
	ULONG cxsigflag  = 0;
	ULONG customflag = 0;

	if((pm_broker == NULL)||(pm_custom == NULL)) return;

	cxsigflag = 1L << pm_broker->mp_SigBit;
	customflag = 1L << pm_custom->mp_SigBit;

	while (returnvalue == TRUE)
    {
        /* wait for something to happen */
        sigrcvd = Wait(SIGBREAKF_CTRL_C | cxsigflag | customflag);

		/* fisrt loop: is Msg a commodity command ? */
		while((msg = (CxMsg *)GetMsg(pm_broker)) != NULL)
        {
            /* Extract necessary information from the CxMessage and return it */
            msgid = CxMsgID(msg);
            msgtype = CxMsgType(msg);
            ReplyMsg((struct Message *)msg);

            switch(msgtype)
            {
                case CXM_COMMAND:
                    /* Commodities has sent a command */
                    switch(msgid)
                    {
                        /* user want to deactivate commmodity */
                        case CXCMD_DISABLE:
                            ActivateCxObj(broker, FALSE);
                            break;

                        /* user want to (re)activate commodity */
                        case CXCMD_ENABLE:
                            ActivateCxObj(broker, TRUE);
                            break;

                        /* user want to kill commodity */
                        case CXCMD_KILL:
                            returnvalue = FALSE;
                            break;
                    }
                    break;
                default:
                    printf("Unknown msgtype\n");
                    break;
            }
        }

        /* second loop: application commands */
		while((msg2 = (struct Mymsg *) GetMsg(pm_custom)) != NULL)
        {
            switch(msg2->ID)
            {
                case ID_DOUBLECLICK :
kprintf("ProcessMsg : ID_DOUBLECLICK : pass0\n");
					if(IsMouseOverWB())
					{
                        struct Process *proc;
                        struct TaskData *td;
                        char dummy[50];
                        long ID;

kprintf("ProcessMsg : ID_DOUBLECLICK : pass1\n");
						if((td=malloc(sizeof(struct TaskData))) != NULL)
                        {   ID = GetUniqueID();
                            sprintf(dummy,"%s%ld",CXPrefs.Lister_TaskName,ID);
kprintf("ProcessMsg : ID_DOUBLECLICK : pass1\n");
Forbid();
							proc = CreateNewProcTags(NP_Entry, 		MainLister,
													 NP_StackSize, 	CXPrefs.Lister_Stack,
													 NP_Name, 		dummy,
													 NP_CodeType, 	MACHINE_PPC,
													 NP_ExitCode, 	&ExitCode_GATE,
													 NP_ExitData, 	ID,
													 TAG_DONE);
kprintf("ProcessMsg : ID_DOUBLECLICK : pass2\n");
                            td->Env = &Env;
                            td->Unique_ID = ID;
                            proc->pr_Task.tc_UserData = td;
                            AddListerProcess(proc);
Permit();
kprintf("ProcessMsg : ID_DOUBLECLICK : pass3\n");
                        }
					  kprintf("Double clicked on the Wordkbench screen !\n");
                    }

                    FreeVec(msg2);
                    break;

				//case ID_MOUSEUP :
				//	  CheckDrop();
				//	  FreeVec(msg2);
				//break;
            }
        }

        /* Test to see if user tried to break */
        if (sigrcvd & SIGBREAKF_CTRL_C)
        {
            returnvalue = FALSE;
            printf("\nCTRL C signal break\n");
        }
    }
}

/**************************************************************/
/* for each system Msg, this function test it and send a msg  */
/* to the aplication if it's a interesting user action for us */
/* interesting Msg (action) for us is:                        */
/* - Mouse Double click (button depends on user configuration)*/
/**************************************************************/
static void MsgTesterPPC(void)
{
	static ULONG secs=0,ms=0;      /* used for doubleclick test in MsgTester */
	CxMsg *msg = (CxMsg *)REG_A0;  //SS-TBD : handle amigaos and morphos here
	CxObj *obj = (CxObj *)REG_A1;

    /* get system message... */
	struct InputEvent *ie 			= (struct InputEvent *) CxMsgData(msg);
	struct MsgPort    *custom_mp    = (struct MsgPort*) CxMsgID(msg);

	if((ie == NULL) || (custom_mp == NULL))	return;

	// ...and test if it's for us
	// is it a mouse double click ?
    if (ie->ie_Class == IECLASS_RAWMOUSE && ie->ie_Code == CXPrefs.MouseButton)
    {   if(DoubleClick(secs,ms,ie->ie_TimeStamp.tv_secs,ie->ie_TimeStamp.tv_micro))
		{   if((MyMsg = AllocVec(sizeof(struct Mymsg), MEMF_PUBLIC|MEMF_CLEAR)) != NULL)
            {   secs = 0;
                ms   = 0;
                MyMsg->ID = ID_DOUBLECLICK;
				PutMsg(custom_mp,(struct Message *)MyMsg); // User double clicked: notify our own application
            }
        }
        else
        {   secs = ie->ie_TimeStamp.tv_secs;
            ms   = ie->ie_TimeStamp.tv_micro;
        }
    }
	// is it a left Mouse UP ?
    else if(ie->ie_Class == IECLASS_RAWMOUSE && ie->ie_Code == SELECTUP)
			if((MyMsg = AllocVec(sizeof(struct Mymsg), MEMF_PUBLIC|MEMF_CLEAR)) != NULL)
            {   MyMsg->ID = ID_MOUSEUP;
				PutMsg(custom_mp,(struct Message *)MyMsg); // User left clicked: notify our own application
			}
}


