#ifndef MAIN_H
#define MAIN_H

/* amiga */
#include <exec/libraries.h>
#include <graphics/layers.h>
#include <dos/dos.h>
#include <dos/dostags.h>
#include <clib/alib_protos.h>
#include <libraries/mui.h>
#include <libraries/gadtools.h>
#include <libraries/commodities.h>
#include <utility/utility.h>
#include <workbench/workbench.h>
#include <emul/emulregs.h>

/* proto */
#include <proto/exec.h>
#include <proto/commodities.h>
#include <proto/layers.h>
#include <proto/dos.h>
#include <proto/wb.h>
#include <proto/utility.h>

/*  Ansi  */
#include <string.h>
#include <stdio.h>


/* commodity constants */
#define MAGICTASK_DEFAULT_NAME  "Workbench"
#define DEFAULT_MOUSE_BUTTON    "LMB"
#define DEFAULT_LISTER_STACK     32768
//SS-TBD 16384
#define DEFAULT_LISTER_TASKNAME "New_Lister"
#define COMMODITY_NAME          "Listers"
#define COMMODITY_TITLE         "Listers 0.1"
#define COMMODITY_DESC          "Magellan like listers for Workbench"

/* IDs for custom message */
#define ID_DOUBLECLICK  1
#define ID_MOUSEUP      2


/* commodity prefs struct */
struct CXPREFS
{   STRPTR MagicTask;               /* Name of the Task that will react on a double click on the background (ie: Workbench,Dopus,etc.)  */
    UWORD  MouseButton;             /* Mouse button to double click to make a lister appear                                             */
    ULONG  Lister_Stack;            /* Default stack for each lister process                                                            */
    STRPTR Lister_TaskName;         /* Default name for each lister task                                                                */
}CXPrefs;

/* chained list struct for listers */
struct MyList
{   struct MyList *Head,*Tail;      /* Head and tail for chained list management    */
    struct Process *Lister_process; /* pointer to Lister process                    */
    APTR Lister_App;                /* pointer to Lister Mui Application Object     */
    ULONG Unique_ID;                /* Unique ID that identify a lister             */
};

/* main Environement struct */
struct Environement
{   struct MyList *Lister_list;  /* Chained list of opened Listers                                                      */
    struct MyList *Last_lister;  /* pointer to the tail of Lister_list (for easy adding of new entities)                */
    int Nb_Opened_Listers;       /* contain actually number of opened listers                                           */
    ULONG Dragged_ID;            /* Contain ID of the lister wich has just began to drag something, NULL if no drag     */
}Env;

/* struct used to store private datas in each lister task */
struct TaskData
{   struct Environement *Env;       /* Pointer to Main Environement                                                                 */
    ULONG Unique_ID;                /* Unique ID that identify a lister (so we can, in a lister task, known in wich lister we are)  */
};

/* custom message sructure */
struct Mymsg
{   struct Message msg;
    ULONG ID;
};

/* Needed protos */
struct MyList * GetNodeByID(ULONG ID, struct MyList *node);
#endif
